# adopted from https://github.com/beeevita/EvoPrompt/blob/bf43b0dcc63fb79b7c0007d4693b2c0721e9a1a7/data/template_de.py

DE_COT_PROMPTS = [
    "Step 1: Identify the different parts between the Prompt 1 and Prompt 2:\nPrompt 1: {prompt1}\nPrompt 2: {prompt2}",
    "Step 2: Randomly mutate the different parts",
    "Step 3: Combine the different parts with Prompt 3, selectively replace it with the different parts in Step 2 and generate a new prompt.\nPrompt 3: {prompt3}",
    "Step 4: Cross over the prompt in the Step 3 with the following basic prompt and generate a final prompt bracketed with <prompt> and </prompt>:\nBasic Prompt: {basic_prompt}",
]

# NOTE that the phrase "Please follow ..." was removed since this is already part of our system message although model inputs will look slightly different though.
DE_COT_DEMONSTRATION_DATA_SIM = [
    {
        "prompt1": "Rewrite the input text into simpler text.",
        "prompt2": "Rewrite my complex sentence in simpler terms, but keep the meaning.",
        "generation_prefix": "1. ",
        "response": (
            "1. Identifying the different parts between Prompt 1 and Prompt 2:\n"
            "Prompt 1: Rewrite the input text into simpler text.\n"
            "Prompt 2: Rewrite my complex sentence in simpler terms, but keep the meaning.\n"
            "Different parts:\n"
            '"input text" vs "my complex sentence"\n'
            '"simpler text" vs "simpler terms, but keep the meaning"'
        ),
    },
    {
        "generation_prefix": "2. ",
        "response": (
            "2. Randomly mutate the different parts:\n"
            '"input text" -> "provided text"\n'
            '"my complex sentence" -> "the difficult sentence"\n'
            '"simpler text" -> "easier language"\n'
            '"simpler terms, but keep the meaning" -> "simpler words while maintaining the meaning"'
        ),
    },
    {
        "prompt3": "Rewrite the given input text into simpler English sentences while preserving the same meaning, so it can be understood by non-native English speakers.",
        "generation_prefix": "3. ",
        "response": (
            "3. Combine the different parts with Prompt 3, selectively replace it with the different parts in step 2 and generate a new prompt:\n"
            "Prompt 3: Rewrite the given input text into simpler English sentences while preserving the same meaning, so it can be understood by non-native English speakers.\n"
            "New Prompt: Transform the provided text into easier language while maintaining the meaning, making it accessible for non-native English speakers."
        ),
    },
    {
        "basic_prompt": "Make the sentence easier for people who do not speak English fluently to comprehend.",
        "generation_prefix": "4. ",
        "response": (
            "4. Crossover the prompt in step 3 with the following basic prompt and generate a final prompt bracketed with <prompt> and </prompt>:\n"
            "Basic Prompt: Make the sentence easier for people who do not speak English fluently to comprehend.\n"
            "Final Prompt: <prompt>Convert the difficult sentence into simpler words while preserving the meaning, so it's easier for non-native English speakers to understand.</prompt>"
        ),
    },
]

DE_COT_DEMONSTRATION_DATA_CLS = [
    {
        "prompt1": "Your task is to classify the comment as one of the following categories: terrible, bad, okay, good, great.",
        "prompt2": "In this task, you are given sentences from movie reviews. The task is to classify a sentence as one of the following categories: terrible, bad, okay, good, great.",
        "generation_prefix": "1. ",
        "response": (
            "1. Identifying the different parts between Prompt 1 and Prompt 2:\n"
            "Prompt 1: Your task is to classify the comment as one of the following categories: terrible, bad, okay, good, great.\n"
            "Prompt 2: In this task, you are given sentences from movie reviews. The task is to classify a sentence as one of the following categories: terrible, bad, okay, good, great.\n"
            "Different parts:\n"
            '"classify the comment" vs "classify a sentence"\n'
            '"Your task is to" vs "In this task, you are given sentences from movie reviews. The task is to"'
        ),
    },
    {
        "generation_prefix": "2. ",
        "response": (
            "2. Randomly mutate the different parts:\n"
            '"classify the comment" -> "categorize the statement"\n'
            '"classify a sentence" -> "evaluate the review"\n'
            '"Your task is to" -> "Your mission is to"\n'
            '"In this task, you are given sentences from movie reviews. The task is to" -> "In this assignment, you will receive movie review sentences. Your job is to"'
        ),
    },
    {
        "prompt3": "Assess a movie or a book based on its explanation and determine the sentiment of the movie review. Have your colleague's evaluation of the movie they watched be expressed in a concise remark (e.g. awesome, all right, terrible, or horrendous) following the narrative synopsis they were provided, and choose from terrible, bad, okay, good and great to describe the movie.",
        "generation_prefix": "3. ",
        "response": (
            "3. Combine the different parts with Prompt 3, selectively replace it with the different parts in step 2 and generate a new prompt:\n"
            "Prompt 3: Assess a movie or a book based on its explanation and determine the sentiment of the movie review. Have your colleague's evaluation of the movie they watched be expressed in a concise remark (e.g. awesome, all right, terrible, or horrendous) following the narrative synopsis they were provided, and choose from terrible, bad, okay, good and great to describe the movie.\n"
            "New Prompt: In this assignment, you will receive movie review sentences. Your job is to evaluate the review and determine the sentiment, choosing from terrible, bad, okay, good, and great to describe the movie."
        ),
    },
    {
        "basic_prompt": "You are a sentiment classifier. To do this, you must first understand the meaning of the sentence and any relevant context. And then you should classify it as one of the following categories: terrible, bad, okay, good, great.",
        "generation_prefix": "4. ",
        "response": (
            "4. Crossover the prompt in step 3 with the following basic prompt and generate a final prompt bracketed with <prompt> and </prompt>:\n"
            "Basic Prompt: You are a sentiment classifier. To do this, you must first understand the meaning of the sentence and any relevant context. And then you should classify it as one of the following categories: terrible, bad, okay, good, great.\n"
            "Final Prompt: <prompt>Your mission is to categorize the statement from a movie review by understanding its meaning and context, and then classify it as one of the following categories: terrible, bad, okay, good, or great.</prompt>"
        ),
    },
]
